package org.pigeonblood.test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.transform.sax.SAXSource;

import org.lixm.core.common.LIXMException;
import org.lixm.core.common.XMLType;
import org.lixm.core.common.LIXMPhaseException;
import org.lixm.core.list.XMLDocumentList;
import org.lixm.core.model.AbstractModel;
import org.pigeonblood.impl.core.list.SimpleDocumentList;
import org.pigeonblood.impl.core.modelizer.PushXMLModelizer;
import org.pigeonblood.impl.core.modelizer.PushXMLModelizer.DefaultModelizeResolver;
import org.pigeonblood.impl.optional.cnif.AbstractXMLCrawler;
import org.pigeonblood.impl.optional.cnif.AbstractXMLIndexer;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * cnif̃eXg
 * TODO ܂sS
 * @author tasogare
 *
 */
public class Test4 {

	PushXMLModelizer modelizer;
	SimpleDocumentList list;
	File xmlFile;
	SAXSource xmlSource;

	TestXMLCrawler crawler;
	TestXMLIndexer indexer;

	/**
	 * @param args
	 * @throws InterruptedException 
	 * @throws LIXMPhaseException 
	 */
	public static void main(
	    String[] args) throws InterruptedException, LIXMPhaseException
	{
		Test4 test = new Test4(args);
		try {
	        test.modelizer.modelize( );
        } catch ( LIXMPhaseException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }

        test.indexer = new TestXMLIndexer(new SimpleDocumentList(100));
        test.crawler = new TestXMLCrawler(test.list, test.indexer);

        System.out.println("Xg̃TCY : " + test.list.size( ));

        try {
	        test.crawler.dispath( );
        } catch ( LIXMException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }

        XMLDocumentList<AbstractModel> list = null;
        try {
        	list = test.indexer.getList( );
        } catch ( LIXMPhaseException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }

        System.out.println("VXg̃TCYF" + list.size( ));

        for(AbstractModel model : list){
        	if(model.getXMLType( ) == XMLType.START_DOCUMENT){
        		System.out.println("͂̊Jn");
        	}else if(model.getXMLType( ) == XMLType.END_DOCUMENT){
        		System.out.println("͂̏I");
        	}else{
        		System.out.println(model);
        	}
        }
	}

	public Test4(String[] args){
		xmlFile = analizeArgs(args);

		createXMLSource();
		createXMLDocumentList();
		createXMLModelizer();
	}

	private final File analizeArgs(String[] args){

		if(args.length != 1){
			usage();
			System.exit(1);
		}

		return new File(args[0]);
	}

	private final void createXMLSource(){
		try {
	        xmlSource = new SAXSource(new InputSource(new FileReader(xmlFile)));
        } catch ( FileNotFoundException e ) {
	        throw new AssertionError("xmlt@C܂B");
        }
	}

	private final void createXMLModelizer(){

		if(xmlSource == null){
			throw new AssertionError("XML\[X܂B");
		}

		if(list == null){
			throw new AssertionError("Xg܂B");
		}

		modelizer = (PushXMLModelizer) PushXMLModelizer.newInstance(xmlSource, list);

		SAXParserFactory xrf = SAXParserFactory.newInstance( );
		xrf.setNamespaceAware(true);

		try {
	        SAXParser r = xrf.newSAXParser( );

	        DefaultModelizeResolver resolver = modelizer.new DefaultModelizeResolver( );

	        r.setProperty("http://xml.org/sax/properties/lexical-handler", resolver);

	        r.getXMLReader( ).setContentHandler(resolver);
	        xmlSource.setXMLReader(r.getXMLReader( ));

		} catch ( ParserConfigurationException e ) {
	        e.printStackTrace();
	        System.exit(1);
        } catch ( SAXException e ) {
	        e.printStackTrace();
	        System.exit(1);
        }
	}

	private final void createXMLDocumentList(){
		list = new SimpleDocumentList(100);
	}

	private final void usage() {
        System.out.println("Usage:");
        System.out.println("\t\tjava Test4 input_xml_file");
    }

}

class TestXMLCrawler extends AbstractXMLCrawler {

    public TestXMLCrawler(
        SimpleDocumentList list, AbstractXMLIndexer indexer)
    {
	    super(list, indexer);
    }

    @Override public boolean accept(
        AbstractModel model) throws LIXMPhaseException
    {
	    return ( 
	    	model.matchTypes(XMLType.START_DOCUMENT) ||
	    	model.matchTypes(XMLType.END_DOCUMENT) ||
	    	model.matchTypes(XMLType.START_TAG) ||
	    	model.matchTypes(XMLType.END_TAG) 
	    );
    }

}

class TestXMLIndexer extends AbstractXMLIndexer {

    public TestXMLIndexer(
        SimpleDocumentList list)
    {
	    super(list);
    }

    @Override public int compare(
        AbstractModel arg0, AbstractModel arg1)
        throws UnsupportedOperationException
    {
	    return 0;
    }

}
